#include <list>
#include <vector>
#include <queue>
#include "node.h"
#include "edge.h"

#define A_IS_BEHIND_B 0
#define B_IS_BEHIND_A 1
#define NO_OVERLAP 2
#define ALL false
#define DYNAMIC true

class CDepthsorting{

private:
	std::vector<node*> nodeIndex;
	std::list<edge> edgeList;
	std::list<edge> storedEdgeList;
	std::list<int> resultList;

	void cleanUp();
	void determineEdges(bool);
	void removeEdgesFrom(int);
	int hexagonOverlap(node a, node b);
	void attemptLoopRemoval();
	void removeDynamicEdges();

	void optimizeStoredEdgeList();
	bool checkObsolete(int, int, int, int);

	int handleIntersection(node* a, node* b, int responceA, int responceB, int result);


public:
	CDepthsorting();
	~CDepthsorting();

	int addNode(int, int, int, int, int, int, bool, int responce);
	int moveNode(int, int, int, int, int, int, int);
	void topologicalSort();
	int nodeIndexGetSize();
	void copyResultToString(char*);

};