#define gmexport extern "C" __declspec (dllexport)

#include <iostream>
#include "CDepthsorting.h"

CDepthsorting* sortingObject;
char* returnstring = nullptr;


gmexport double depthsorting_initiate(){

	if (sortingObject != nullptr)
		delete sortingObject;

	sortingObject = new CDepthsorting;

	return 1;

}

gmexport double depthsorting_add_object(double x, double w, double y, double d, double z, double h, double dynamic, double responce){
	if (sortingObject != nullptr){
		return (double)sortingObject->addNode((int)x, (int)w, (int)y, (int)d, (int)z, (int)h, (dynamic == 0 ? false : true), (int)responce);
	}
	else
		return -1;
}

gmexport double depthsorting_move_object(double id, double x, double w, double y, double d, double z, double h){
	if (sortingObject != nullptr){
		return (double)sortingObject->moveNode((int)id, (int)x, (int)w, (int)y, (int)d, (int)z, (int)h);
	}
	else
		return -1;
}

gmexport char* depthsorting_perform_sort(){
	
	if (sortingObject != nullptr){

		sortingObject->topologicalSort();

		if (returnstring != nullptr){
			delete returnstring;
			returnstring = nullptr;
		}

		int len = 2 * sortingObject->nodeIndexGetSize() + 1;

		returnstring = new char[len];

		sortingObject->copyResultToString(returnstring);


		returnstring[len - 1] = '\0';


		return returnstring;
	}
	else{
		if (returnstring != nullptr){
			delete returnstring;
			returnstring = nullptr;
		}
		returnstring = new char[1];
		returnstring[0] = '\0';
		return returnstring;
	}
}

gmexport double depthsorting_close(){
	if (returnstring != nullptr){
		delete returnstring;
		returnstring = nullptr;
	}

	if (sortingObject != nullptr){
		delete sortingObject;
		sortingObject = nullptr;
	}
	return 1;
}